Index: palm/trunk/SOURCE/biometeorology_mod.f90
===================================================================
--- palm/trunk/SOURCE/biometeorology_mod.f90	(revision 4143)
+++ palm/trunk/SOURCE/biometeorology_mod.f90	(revision 4144)
@@ -27,4 +27,7 @@
 ! -----------------
 ! $Id$
+! relational operators .EQ., .NE., etc. replaced by ==, /=, etc.
+! 
+! 4127 2019-07-30 14:47:10Z suehring
 ! Output for bio_mrt added (merge from branch resler)
 ! 
@@ -4319,7 +4322,7 @@
 !
 !-- calculation of solar azimuth angle
-    IF (woz .LE. 12.0_wp) alpha = pi - acos( ( sin(thetasr) * sin( lat * dtor ) -                                     &
+    IF (woz <= 12.0_wp) alpha = pi - acos( ( sin(thetasr) * sin( lat * dtor ) -                                     &
     sin( declination * dtor ) ) / ( cos(thetasr) * cos( lat * dtor ) ) )    
-    IF (woz .GT. 12.0_wp) alpha = pi + acos( ( sin(thetasr) * sin( lat * dtor ) -                                     &
+    IF (woz > 12.0_wp)  alpha = pi + acos( ( sin(thetasr) * sin( lat * dtor ) -                                     &
     sin( declination * dtor ) ) / ( cos(thetasr) * cos( lat * dtor ) ) )    
     saa = alpha / dtor
@@ -4347,5 +4350,5 @@
     CALL uvem_solar_position
      
-    IF (sza  .GE.  90)  THEN
+    IF (sza  >=  90)  THEN
        vitd3_exposure(:,:) = 0.0_wp
     ELSE
@@ -4446,5 +4449,5 @@
              IF (consider_obstructions )  THEN
                 obstruction_temp1 = building_obstruction_f%var_3d(:,j,i)
-                IF (obstruction_temp1(0)  .NE.  9)  THEN 
+                IF ( obstruction_temp1(0)  /=  9 )  THEN
                    DO  pobi = 0, 44 
                       DO  bi = 0, 7 
@@ -4468,5 +4471,5 @@
          
              obstruction_direct_beam = obstruction( nint(startpos_saa_float), nint( sza / 10.0_wp ) ) 
-             IF (sza  .GE.  89.99_wp)  THEN
+             IF (sza  >=  89.99_wp)  THEN
                 sza = 89.99999_wp
              ENDIF
Index: palm/trunk/SOURCE/chem_emissions_mod.f90
===================================================================
--- palm/trunk/SOURCE/chem_emissions_mod.f90	(revision 4143)
+++ palm/trunk/SOURCE/chem_emissions_mod.f90	(revision 4144)
@@ -27,4 +27,7 @@
 ! -----------------
 ! $Id$
+! relational operators .EQ., .NE., etc. replaced by ==, /=, etc.
+! 
+! 4055 2019-06-27 09:47:29Z suehring
 ! - replaced local thermo. constants w/ module definitions in
 !   basic_constants_and_equations_mod (rgas_univ, p_0, r_d_cp) 
@@ -724,5 +727,5 @@
                 END DO     ! ind_mod
 
-             ELSE  ! if len_index_voc .le. 0
+             ELSE  ! if len_index_voc <= 0
 
 !
Index: palm/trunk/SOURCE/date_and_time_mod.f90
===================================================================
--- palm/trunk/SOURCE/date_and_time_mod.f90	(revision 4143)
+++ palm/trunk/SOURCE/date_and_time_mod.f90	(revision 4144)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! relational operators .EQ., .NE., etc. replaced by ==, /=, etc.
+! 
+! 3839 2019-03-28 21:12:25Z moh.hefny
 ! further tabs removed, unused variables removed
 ! 
@@ -191,5 +194,5 @@
 
           !> Condition for printing an error when date_init is not provided when day_of_year_init is not given in the namelist or when the format of the date is not the one required by PALM. 
-          IF ( day_of_month .GT. 0 .AND. day_of_month .LE. 31 .AND. month_of_year .GT. 0 .AND. month_of_year .LE. 12) THEN
+          IF ( day_of_month > 0 .AND. day_of_month <= 31 .AND. month_of_year > 0 .AND. month_of_year <= 12) THEN
         
              IF ( month_of_year == 1 ) THEN  !!month of year is read in input
@@ -226,5 +229,5 @@
 
          
-          IF ( day_of_year .LE. 31 ) THEN
+          IF ( day_of_year <= 31 ) THEN
 
              month_of_year=1
@@ -234,5 +237,5 @@
 
              DO i_mon=2,12   !january is considered in the first case
-                IF ( day_of_year .LE. SUM(days(1:i_mon)) .AND. day_of_year .GT. SUM(days(1:(i_mon-1))) ) THEN
+                IF ( day_of_year <= SUM(days(1:i_mon)) .AND. day_of_year > SUM(days(1:(i_mon-1))) ) THEN
            
                    month_of_year=i_mon
@@ -249,5 +252,5 @@
        !> in the second condition both day of month and month_of_year are either given in input (passed to date_init) or we are in some day successive to the initial one, so that day_of_month has already be computed in previous step
        !>TBD: something to calculate the current year is missing
-       ELSEIF ( day_of_month .GT. 0 .AND. day_of_month .LE. 31 .AND. month_of_year .GT. 0 .AND. month_of_year .LE. 12) THEN
+       ELSEIF ( day_of_month > 0 .AND. day_of_month <= 31 .AND. month_of_year > 0 .AND. month_of_year <= 12) THEN
  
           !> calculate month_of_year. TBD: test the condition when day_of_year==31
@@ -257,5 +260,5 @@
              month_of_year = 1
         
-          ELSE IF (day_of_year .GT. 1 .AND. day_of_year .GT. SUM(days(1:month_of_year))) THEN
+          ELSE IF (day_of_year > 1 .AND. day_of_year > SUM(days(1:month_of_year))) THEN
 
              month_of_year = month_of_year + 1
@@ -319,5 +322,5 @@
 
           !> Condition for printing an error when date_init is not provided when day_of_year_init is not given in the namelist or when the format of the date is not the one required by PALM. 
-          IF ( day_of_month .GT. 0 .AND. day_of_month .LE. 31 .AND. month_of_year .GT. 0 .AND. month_of_year .LE. 12) THEN
+          IF ( day_of_month > 0 .AND. day_of_month <= 31 .AND. month_of_year > 0 .AND. month_of_year <= 12) THEN
         
              IF ( month_of_year == 1 ) THEN  !!month of year is read in input
@@ -346,5 +349,5 @@
 
 !--    Calculate current day of the year !TBD: considetr leap years
-       IF ( (day_of_year_init + days_since_reference_point)  .GT. 365 ) THEN
+       IF ( (day_of_year_init + days_since_reference_point)  > 365 ) THEN
 
           day_of_year=INT(MOD((day_of_year_init + days_since_reference_point), 365.0_wp))
@@ -369,6 +372,6 @@
           !> The first case is when date_init is not provided: we only know day_of_year_init
           !DO i_mon=1,12
-             !IF (day_of_year .LE. SUM(days(1:i_mon))) THEN
-          IF ( day_of_year .LE. 31 ) THEN
+             !IF (day_of_year <= SUM(days(1:i_mon))) THEN
+          IF ( day_of_year <= 31 ) THEN
 
              month_of_year=1
@@ -378,5 +381,5 @@
 
              DO i_mon=2,12   !january is considered in the first case
-                IF ( day_of_year .LE. SUM(days(1:i_mon)) .AND. day_of_year .GT. SUM(days(1:(i_mon-1))) ) THEN
+                IF ( day_of_year <= SUM(days(1:i_mon)) .AND. day_of_year > SUM(days(1:(i_mon-1))) ) THEN
            
                    month_of_year=i_mon
@@ -393,5 +396,5 @@
        !> in the second condition both day of month and month_of_year are either given in input (passed to date_init) or we are in some day successive to the initial one, so that day_of_month has already be computed in previous step
        !>TBD: something to calculate the current year is missing
-       ELSEIF ( day_of_month .GT. 0 .AND. day_of_month .LE. 31 .AND. month_of_year .GT. 0 .AND. month_of_year .LE. 12) THEN
+       ELSEIF ( day_of_month > 0 .AND. day_of_month <= 31 .AND. month_of_year > 0 .AND. month_of_year <= 12) THEN
  
           !> calculate month_of_year. TBD: test the condition when day_of_year==31
@@ -401,5 +404,5 @@
              month_of_year = 1
         
-          ELSE IF (day_of_year .GT. 1 .AND. day_of_year .GT. SUM(days(1:month_of_year))) THEN
+          ELSE IF (day_of_year > 1 .AND. day_of_year > SUM(days(1:month_of_year))) THEN
 
              month_of_year = month_of_year + 1
Index: palm/trunk/SOURCE/indoor_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/indoor_model_mod.f90	(revision 4143)
+++ palm/trunk/SOURCE/indoor_model_mod.f90	(revision 4144)
@@ -26,4 +26,7 @@
 ! -----------------
 ! $Id$
+! relational operators .EQ., .NE., etc. replaced by ==, /=, etc.
+! 
+! 3885 2019-04-11 11:29:34Z kanani
 ! Changes related to global restructuring of location messages and introduction 
 ! of additional debug messages
@@ -454,5 +457,5 @@
           IF ( building_id_f%var(j,i) /= building_id_f%fill )  THEN
              IF ( num_buildings_l(myid) > 0 )  THEN
-                IF ( ANY( building_id_f%var(j,i) .EQ.  build_ids_l ) )  THEN 
+                IF ( ANY( building_id_f%var(j,i) ==  build_ids_l ) )  THEN
                    CYCLE
                 ELSE
@@ -521,5 +524,5 @@
 
        IF ( ALLOCATED(build_ids_final) )  THEN
-          IF ( ANY( build_ids(n) .EQ. build_ids_final ) )  THEN    !FK: Warum ANY?, Warum .EQ.? --> s.o
+          IF ( ANY( build_ids(n) == build_ids_final ) )  THEN    !FK: Warum ANY?, Warum .EQ.? --> s.o
              CYCLE
           ELSE
Index: palm/trunk/SOURCE/init_grid.f90
===================================================================
--- palm/trunk/SOURCE/init_grid.f90	(revision 4143)
+++ palm/trunk/SOURCE/init_grid.f90	(revision 4144)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! relational operators .EQ., .NE., etc. replaced by ==, /=, etc.
+! 
+! 4115 2019-07-24 12:50:49Z suehring
 ! Bugfix in setting near-surface flag 24, inidicating wall-bounded grid points 
 ! 
@@ -1469,5 +1472,5 @@
                 IF ( building_id_f%var(j,i) /= building_id_f%fill )  THEN
                    IF ( num_buildings_l(myid) > 0 )  THEN
-                      IF ( ANY( building_id_f%var(j,i) .EQ.  build_ids_l ) )   &
+                      IF ( ANY( building_id_f%var(j,i) ==  build_ids_l ) )   &
                       THEN
                          CYCLE
@@ -1543,5 +1546,5 @@
 
              IF ( ALLOCATED(build_ids_final) )  THEN
-                IF ( ANY( build_ids(nr) .EQ. build_ids_final ) )  THEN
+                IF ( ANY( build_ids(nr) == build_ids_final ) )  THEN
                    CYCLE
                 ELSE
@@ -1574,5 +1577,5 @@
              oro_max_l(nr) = MAXVAL(                                              &
                               MERGE( terrain_height_f%var, 0.0_wp,                &
-                                     building_id_f%var(nys:nyn,nxl:nxr) .EQ.      &
+                                     building_id_f%var(nys:nyn,nxl:nxr) ==      &
                                      build_ids_final(nr) ) )
           ENDDO
Index: palm/trunk/SOURCE/lagrangian_particle_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/lagrangian_particle_model_mod.f90	(revision 4143)
+++ palm/trunk/SOURCE/lagrangian_particle_model_mod.f90	(revision 4144)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! relational operators .EQ., .NE., etc. replaced by ==, /=, etc.
+! 
+! 4143 2019-08-05 15:14:53Z schwenkel
 ! Rename variable and change select case to if statement
 ! 
@@ -1387,6 +1390,6 @@
 !
 !--                            In case of stretching the actual k index is found iteratively
-                               IF ( dz_stretch_level .NE. -9999999.9_wp  .OR.           &
-                                    dz_stretch_level_start(1) .NE. -9999999.9_wp )  THEN
+                               IF ( dz_stretch_level /= -9999999.9_wp  .OR.           &
+                                    dz_stretch_level_start(1) /= -9999999.9_wp )  THEN
                                   kp = MINLOC( ABS( tmp_particle%z - zu ), DIM = 1 ) - 1
                                ELSE
@@ -1648,13 +1651,13 @@
 !
 !-- Set constants for different aerosol species
-    IF ( TRIM(aero_species) .EQ. 'nacl' )  THEN
+    IF ( TRIM(aero_species) == 'nacl' )  THEN
        molecular_weight_of_solute = 0.05844_wp 
        rho_s                      = 2165.0_wp
        vanthoff                   = 2.0_wp
-    ELSEIF ( TRIM(aero_species) .EQ. 'c3h4o4' )  THEN
+    ELSEIF ( TRIM(aero_species) == 'c3h4o4' )  THEN
        molecular_weight_of_solute = 0.10406_wp 
        rho_s                      = 1600.0_wp
        vanthoff                   = 1.37_wp
-    ELSEIF ( TRIM(aero_species) .EQ. 'nh4o3' )  THEN
+    ELSEIF ( TRIM(aero_species) == 'nh4o3' )  THEN
        molecular_weight_of_solute = 0.08004_wp 
        rho_s                      = 1720.0_wp
@@ -1668,33 +1671,33 @@
 !-- The following typical aerosol spectra are taken from Jaenicke (1993):
 !-- Tropospheric aerosols. Published in Aerosol-Cloud-Climate Interactions.
-    IF ( TRIM(aero_type) .EQ. 'polar' )  THEN
+    IF ( TRIM(aero_type) == 'polar' )  THEN
        na        = (/ 2.17e1, 1.86e-1, 3.04e-4 /) * 1.0E6_wp
        rm        = (/ 0.0689, 0.375, 4.29 /) * 1.0E-6_wp
        log_sigma = (/ 0.245, 0.300, 0.291 /)
-    ELSEIF ( TRIM(aero_type) .EQ. 'background' )  THEN
+    ELSEIF ( TRIM(aero_type) == 'background' )  THEN
        na        = (/ 1.29e2, 5.97e1, 6.35e1 /) * 1.0E6_wp
        rm        = (/ 0.0036, 0.127, 0.259 /) * 1.0E-6_wp
        log_sigma = (/ 0.645, 0.253, 0.425 /)
-    ELSEIF ( TRIM(aero_type) .EQ. 'maritime' )  THEN
+    ELSEIF ( TRIM(aero_type) == 'maritime' )  THEN
        na        = (/ 1.33e2, 6.66e1, 3.06e0 /) * 1.0E6_wp
        rm        = (/ 0.0039, 0.133, 0.29 /) * 1.0E-6_wp
        log_sigma = (/ 0.657, 0.210, 0.396 /)
-    ELSEIF ( TRIM(aero_type) .EQ. 'continental' )  THEN
+    ELSEIF ( TRIM(aero_type) == 'continental' )  THEN
        na        = (/ 3.20e3, 2.90e3, 3.00e-1 /) * 1.0E6_wp
        rm        = (/ 0.01, 0.058, 0.9 /) * 1.0E-6_wp
        log_sigma = (/ 0.161, 0.217, 0.380 /)
-    ELSEIF ( TRIM(aero_type) .EQ. 'desert' )  THEN
+    ELSEIF ( TRIM(aero_type) == 'desert' )  THEN
        na        = (/ 7.26e2, 1.14e3, 1.78e-1 /) * 1.0E6_wp
        rm        = (/ 0.001, 0.0188, 10.8 /) * 1.0E-6_wp
        log_sigma = (/ 0.247, 0.770, 0.438 /)
-    ELSEIF ( TRIM(aero_type) .EQ. 'rural' )  THEN
+    ELSEIF ( TRIM(aero_type) == 'rural' )  THEN
        na        = (/ 6.65e3, 1.47e2, 1.99e3 /) * 1.0E6_wp
        rm        = (/ 0.00739, 0.0269, 0.0419 /) * 1.0E-6_wp
        log_sigma = (/ 0.225, 0.557, 0.266 /)
-    ELSEIF ( TRIM(aero_type) .EQ. 'urban' )  THEN
+    ELSEIF ( TRIM(aero_type) == 'urban' )  THEN
        na        = (/ 9.93e4, 1.11e3, 3.64e4 /) * 1.0E6_wp
        rm        = (/ 0.00651, 0.00714, 0.0248 /) * 1.0E-6_wp
        log_sigma = (/ 0.245, 0.666, 0.337 /)
-    ELSEIF ( TRIM(aero_type) .EQ. 'user' )  THEN
+    ELSEIF ( TRIM(aero_type) == 'user' )  THEN
        CONTINUE
     ELSE
@@ -1739,5 +1742,5 @@
 
                 IF ( particles(n)%weight_factor - FLOOR(particles(n)%weight_factor,KIND=wp) &
-                     .GT. random_function( iran_part ) )  THEN
+                     > random_function( iran_part ) )  THEN
                    particles(n)%weight_factor = FLOOR(particles(n)%weight_factor,KIND=wp) + 1.0_wp
                 ELSE
@@ -1746,5 +1749,5 @@
 !
 !--             Unnecessary particles will be deleted
-                IF ( particles(n)%weight_factor .LE. 0.0_wp )  particles(n)%particle_mask = .FALSE.
+                IF ( particles(n)%weight_factor <= 0.0_wp )  particles(n)%particle_mask = .FALSE.
 
              ENDDO
@@ -5103,5 +5106,5 @@
    !--          Check error of the solution, and reduce dt_ros if necessary.
                 error = ABS(r_err - r_ros) / r_ros
-                IF ( error .GT. prec )  THEN
+                IF ( error > prec )  THEN
                    dt_ros = SQRT( q_decrease * prec / error ) * dt_ros
                    r_ros  = r_ros_ini
@@ -5404,5 +5407,5 @@
 !--          For collisions, the weighting factor of at least one super-droplet
 !--          needs to be larger or equal to one.
-             IF ( MIN( weight(n), weight(m) ) .LT. 1.0_wp )  CYCLE
+             IF ( MIN( weight(n), weight(m) ) < 1.0_wp )  CYCLE
 !
 !--          Get mass of individual droplets (aerosols)
@@ -5429,5 +5432,5 @@
 !--          (Accordingly, p_crit will be 0.0, 1.0, 2.0, ...)
              IF ( collection_probability - FLOOR(collection_probability)    &
-                  .GT. random_function( iran_part ) )  THEN
+                  > random_function( iran_part ) )  THEN
                 collection_probability = FLOOR(collection_probability) + 1.0_wp
              ELSE
@@ -5435,8 +5438,8 @@
              ENDIF
 
-             IF ( collection_probability .GT. 0.0_wp )  THEN
+             IF ( collection_probability > 0.0_wp )  THEN
 !
 !--             Super-droplet n collects droplets of super-droplet m
-                IF ( weight(n) .LT. weight(m) )  THEN
+                IF ( weight(n) < weight(m) )  THEN
 
                    mass(n)   = mass(n)   + weight(n) * xm * collection_probability
@@ -5448,5 +5451,5 @@
                    ENDIF
 
-                ELSEIF ( weight(m) .LT. weight(n) )  THEN
+                ELSEIF ( weight(m) < weight(n) )  THEN
 
                    mass(m)   = mass(m)   + weight(m) * xn * collection_probability
@@ -7615,6 +7618,6 @@
 !
 !--    In case of stretching the actual k index must be found
-       IF ( dz_stretch_level .NE. -9999999.9_wp  .OR.         &
-            dz_stretch_level_start(1) .NE. -9999999.9_wp )  THEN
+       IF ( dz_stretch_level /= -9999999.9_wp  .OR.         &
+            dz_stretch_level_start(1) /= -9999999.9_wp )  THEN
           kp = MINLOC( ABS( particle_array(n)%z - zu ), DIM = 1 ) - 1
        ELSE
Index: palm/trunk/SOURCE/random_function_mod.f90
===================================================================
--- palm/trunk/SOURCE/random_function_mod.f90	(revision 4143)
+++ palm/trunk/SOURCE/random_function_mod.f90	(revision 4144)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! relational operators .EQ., .NE., etc. replaced by ==, /=, etc.
+! 
+! 3802 2019-03-17 13:33:42Z raasch
 ! type conversion added to avoid compiler warning about constant integer
 ! division truncation
@@ -73,5 +76,5 @@
 ! ------------
 !> Random number generator, produces numbers equally distributed in interval [0,1]
-!> This routine is taken from the "numerical recipies"
+!> This routine is taken from the "numerical recipes"
 !------------------------------------------------------------------------------!
  MODULE random_function_mod
@@ -137,11 +140,11 @@
                    ntab=32, ndiv=1+INT(REAL(im-1)/ntab), eps=1.2e-7_wp, rnmx=1.0_wp-eps )
 
-       IF ( idum .le. 0  .or.  random_iy .eq. 0 )  THEN
+       IF ( idum <= 0  .OR.  random_iy == 0 )  THEN
           idum = max (-idum,1)
           DO  j = ntab+8,1,-1
              k    = idum / iq
              idum = ia * ( idum - k * iq ) - ir * k
-             IF ( idum .lt. 0 )  idum = idum + im
-             IF ( j .le. ntab )  random_iv(j) = idum
+             IF ( idum < 0 )  idum = idum + im
+             IF ( j <= ntab )  random_iv(j) = idum
           ENDDO
           random_iy = random_iv(1)
@@ -150,9 +153,9 @@
        k    = idum / iq
        idum = ia * ( idum - k * iq ) - ir * k
-       IF ( idum .lt. 0 )  idum = idum + im
+       IF ( idum < 0 )  idum = idum + im
        j            = 1 + random_iy / ndiv
        random_iy    = random_iv(j)
        random_iv(j) = idum
-       random_function  = min ( am * random_iy , rnmx )
+       random_function  = MIN( am * random_iy , rnmx )
 
     END FUNCTION random_function
Index: palm/trunk/SOURCE/synthetic_turbulence_generator_mod.f90
===================================================================
--- palm/trunk/SOURCE/synthetic_turbulence_generator_mod.f90	(revision 4143)
+++ palm/trunk/SOURCE/synthetic_turbulence_generator_mod.f90	(revision 4144)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! relational operators .EQ., .NE., etc. replaced by ==, /=, etc.
+! 
+! 4071 2019-07-03 20:02:00Z suehring
 ! Bugfix, initialize mean_inflow_profiles in case turbulence and inflow
 ! information is not read from file. 
@@ -996,18 +999,18 @@
           DO  j = nysg, nyng
              DO  k = nzb, nzt+1
-                IF  ( a11(k) .NE. 0._wp ) THEN
+                IF  ( a11(k) /= 0.0_wp )  THEN
                    fu_yz(k,j) = ( u(k,j,i) - u_init(k) ) / a11(k)
                 ELSE
-                   fu_yz(k,j) = 0._wp
+                   fu_yz(k,j) = 0.0_wp
                 ENDIF
 
-                IF  ( a22(k) .NE. 0._wp ) THEN
+                IF  ( a22(k) /= 0.0_wp )  THEN
                    fv_yz(k,j) = ( v(k,j,i) -                                  &
                                   a21(k) * fu_yz(k,j) - v_init(k) ) / a22(k)
                 ELSE
-                   fv_yz(k,j) = 0._wp
+                   fv_yz(k,j) = 0.0_wp
                 ENDIF
 
-                IF  ( a33(k) .NE. 0._wp ) THEN
+                IF  ( a33(k) /= 0.0_wp )  THEN
                    fw_yz(k,j) = ( w(k,j,i) -                                   &
                                   a31(k) * fu_yz(k,j) - a32(k) *               &
@@ -1029,18 +1032,18 @@
              DO  k = nzb, nzt+1
 
-                IF  ( a11(k) .NE. 0._wp ) THEN
+                IF  ( a11(k) /= 0.0_wp )  THEN
                    fu_xz(k,i) = ( u(k,j,i) - u_init(k) ) / a11(k)
                 ELSE
-                   fu_xz(k,i) = 0._wp
+                   fu_xz(k,i) = 0.0_wp
                 ENDIF
 
-                IF  ( a22(k) .NE. 0._wp ) THEN
+                IF  ( a22(k) /= 0.0_wp )  THEN
                    fv_xz(k,i) = ( v(k,j,i) -                                   &
                                   a21(k) * fu_xz(k,i) - v_init(k) ) / a22(k)
                 ELSE
-                   fv_xz(k,i) = 0._wp
+                   fv_xz(k,i) = 0.0_wp
                 ENDIF
 
-                IF  ( a33(k) .NE. 0._wp ) THEN
+                IF  ( a33(k) /= 0.0_wp )  THEN
                    fw_xz(k,i) = ( w(k,j,i) -                                   &
                                   a31(k) * fu_xz(k,i) -                        &
Index: palm/trunk/SOURCE/time_integration.f90
===================================================================
--- palm/trunk/SOURCE/time_integration.f90	(revision 4143)
+++ palm/trunk/SOURCE/time_integration.f90	(revision 4144)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! relational operators .EQ., .NE., etc. replaced by ==, /=, etc.
+! 
+! 4126 2019-07-30 11:09:11Z gronemeier
 ! renamed routine to calculate uv exposure
 ! 
@@ -1565,5 +1568,5 @@
 !
 !--       Call emission routine only once an hour
-          IF (hour_of_year  .GT.  hour_call_emis )  THEN
+          IF ( hour_of_year  >  hour_call_emis )  THEN
              CALL chem_emissions_setup( chem_emis_att, chem_emis, n_matched_vars )
              hour_call_emis = hour_of_year
Index: palm/trunk/SOURCE/wind_turbine_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/wind_turbine_model_mod.f90	(revision 4143)
+++ palm/trunk/SOURCE/wind_turbine_model_mod.f90	(revision 4144)
@@ -26,4 +26,7 @@
 ! -----------------
 ! $Id$
+! relational operators .EQ., .NE., etc. replaced by ==, /=, etc.
+! 
+! 4056 2019-06-27 13:53:16Z Giersch
 ! CASE DEFAULT action in wtm_actions needs to be CONTINUE. Otherwise an abort  
 ! will happen for location values that are not implemented as CASE statements
@@ -1522,5 +1525,5 @@
 !             lct(1) = lct(1)
 
-          IF ( ( trad1(lct(1)) - cur_r ) .GT. 0.0 )  THEN
+          IF ( ( trad1(lct(1)) - cur_r ) > 0.0 )  THEN
              lct(1) = lct(1) - 1
           ENDIF
@@ -1534,7 +1537,7 @@
           t2 = ttoint2(trow)
 
-          IF ( t1 .EQ. t2 ) THEN  ! if both are the same, the weights are NaN
-             weight_a = 0.5_wp    ! then do interpolate in between same twice
-             weight_b = 0.5_wp    ! using 0.5 as weight
+          IF ( t1 == t2 )  THEN  ! if both are the same, the weights are NaN
+             weight_a = 0.5_wp     ! then do interpolate in between same twice
+             weight_b = 0.5_wp     ! using 0.5 as weight
           ENDIF
 