Index: palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/urban_surface_mod.f90	(revision 4127)
+++ palm/trunk/SOURCE/urban_surface_mod.f90	(revision 4148)
@@ -28,4 +28,10 @@
 ! -----------------
 ! $Id$
+! - Add anthropogenic heat output factors for heating and cooling to building
+!   data base
+! - Move definition of building_pars to usm_init_arrays since it is already
+!   required in the indoor model
+! 
+! 4127 2019-07-30 14:47:10Z suehring
 ! Do not add anthopogenic energy during wall/soil spin-up 
 ! (merge from branch resler)
@@ -781,5 +787,5 @@
 !-- (>700), while intel and gfortran compiler have hard limit of continuation 
 !-- lines of 511.
-    REAL(wp), DIMENSION(0:133,1:7) ::  building_pars
+    REAL(wp), DIMENSION(0:135,1:7) ::  building_pars
 !
 !-- Type for surface temperatures at vertical walls. Is not necessary for horizontal walls. 
@@ -1430,5 +1436,9 @@
            IF ( ALLOCATED( surf_usm_v(l)%iwghf_eb_window ) )  surf_usm_v(l)%iwghf_eb_window = 0.0_wp
         ENDDO
-
+!
+!--     Initialize building-surface properties, which are also required by other modules, 
+!--     e.g. the indoor model.
+        CALL usm_define_pars
+        
         IF ( debug_output )  CALL debug_message( 'usm_init_arrays', 'end' )
         
@@ -3778,7 +3788,4 @@
 
         CALL cpu_log( log_point_s(78), 'usm_init', 'start' )
-!
-!--     Initialize building-surface properties
-        CALL usm_define_pars
 !
 !--     surface forcing have to be disabled for LSF 
@@ -9068,5 +9075,7 @@
            10.0_wp,        &  !< parameter 131 - basic internal heat gains without occupancy of the room
            3.0_wp,         &  !< parameter 132 - storey height
-           0.2_wp          &  !< parameter 133 - ceiling construction height
+           0.2_wp,         &  !< parameter 133 - ceiling construction height
+           0.1_wp,         &  !< parameter 134 - anthropogenic heat output for heating
+           1.333_wp        &  !< parameter 135 - anthropogenic heat output for cooling
                             /)
                             
@@ -9205,5 +9214,7 @@
            8.0_wp,         &  !< parameter 131 - basic internal heat gains without occupancy of the room
            3.0_wp,         &  !< parameter 132 - storey height
-           0.2_wp          &  !< parameter 133 - ceiling construction height
+           0.2_wp,         &  !< parameter 133 - ceiling construction height
+           0.1_wp,         &  !< parameter 134 - anthropogenic heat output for heating
+           1.333_wp        &  !< parameter 135 - anthropogenic heat output for cooling
                             /)
                             
@@ -9342,5 +9353,7 @@
            8.0_wp,         &  !< parameter 131 - basic internal heat gains without occupancy of the room
            3.0_wp,         &  !< parameter 132 - storey height
-           0.2_wp          &  !< parameter 133 - ceiling construction height
+           0.2_wp,         &  !< parameter 133 - ceiling construction height
+           0.1_wp,         &  !< parameter 134 - anthropogenic heat output for heating
+           1.333_wp        &  !< parameter 135 - anthropogenic heat output for cooling
                             /)   
                             
@@ -9479,5 +9492,7 @@
            10.0_wp,        &  !< parameter 131 - basic internal heat gains without occupancy of the room
            3.0_wp,         &  !< parameter 132 - storey height
-           0.2_wp          &  !< parameter 133 - ceiling construction height
+           0.2_wp,         &  !< parameter 133 - ceiling construction height
+           0.1_wp,         &  !< parameter 134 - anthropogenic heat output for heating
+           1.333_wp        &  !< parameter 135 - anthropogenic heat output for cooling
                             /)   
                             
@@ -9616,5 +9631,7 @@
            20.0_wp,        &  !< parameter 131 - basic internal heat gains without occupancy of the room
            3.0_wp,         &  !< parameter 132 - storey height
-           0.2_wp          &  !< parameter 133 - ceiling construction height
+           0.2_wp,         &  !< parameter 133 - ceiling construction height
+           0.0_wp,         &  !< parameter 134 - anthropogenic heat output for heating
+           2.54_wp         &  !< parameter 135 - anthropogenic heat output for cooling
                             /)
                             
@@ -9753,5 +9770,7 @@
            15.0_wp,        &  !< parameter 131 - basic internal heat gains without occupancy of the room
            3.0_wp,         &  !< parameter 132 - storey height
-           0.2_wp          &  !< parameter 133 - ceiling construction height
+           0.2_wp,         &  !< parameter 133 - ceiling construction height
+           -2.0_wp,        &  !< parameter 134 - anthropogenic heat output for heating
+           1.25_wp         &  !< parameter 135 - anthropogenic heat output for cooling
                             /)
                             
@@ -9890,5 +9909,7 @@
            0.0_wp,         &  !< parameter 131 - basic internal heat gains without occupancy of the room
            3.0_wp,         &  !< parameter 132 - storey height
-           0.2_wp          &  !< parameter 133 - ceiling construction height
+           0.2_wp,         &  !< parameter 133 - ceiling construction height
+           0.0_wp,         &  !< parameter 134 - anthropogenic heat output for heating
+           0.0_wp          &  !< parameter 135 - anthropogenic heat output for cooling
                         /)
                         